import {world, system, EquipmentSlot, ItemStack, EntityEquippableComponent} from "@minecraft/server";

system.runInterval( () =>{
  for(let p of world.getPlayers()){
    let equip = p.getComponent(EntityEquippableComponent.componentId);
    let hand = equip.getEquipment(EquipmentSlot.Mainhand);
    let offhand = equip.getEquipment(EquipmentSlot.Offhand);
    let light15 = ["lantern", "sea_lantern", "campfire", "froglight", "end_rod", "lit_pumpkin", "lava_bucket", "glowstone", "shroomlight", "beacon"]
    let light12 = ["soul_lantern", "soul_campfire", "candle", "minecraft:torch"]
    let light9 = ["soul_torch", "soul_torch_offhand", "crying_obsidian"]
    let light7 = ["enchanting_table", "catalyst", "totem_of_undying", "fire_charge", "redstone_torch", "ender_chest", "nether_star"]
    let light5 = ["blaze_powder", "glow_ink_sac", "glow_berries", "glowstone_dust", "enchanted_book", "dragon_breath", "ender_eye", "magma", "blaze_rod", "experience_bottle"]

    let light_all = ["lantern", "sea_lantern", "campfire", "froglight", "minecraft:torch", "soul_lantern", "soul_campfire", "lit_pumpkin", "lava_bucket", "glowstone", "shroomlight", "beacon", "candle","crying_obsidian", "soul_torch", "catalyst", "redstone_torch", "ender_chest", "enchanting_table", "magma", "blaze_rod", "blaze_powder", "glow_ink_sac", "glow_berries", "glowstone_dust"]
    let inv = p.getComponent("inventory").container;

    for(let slot = 0; slot < inv.size; slot++){
      let item = inv.getItem(slot);
      if(item){
        let lore = item.getLore()[0];
        for(let types of torch15){
          if(item.typeId.includes(`${types}`)){
            if(item.typeId != "minecraft:glowstone_dust"){
              if(!lore){
                item.setLore([`Lightning: 15 Blocks`])
                inv.setItem(slot, item)
              }
            }
          }
        }
        for(let types of torch12){
          if(item.typeId.includes(`${types}`)){
            if(!lore){
              if(!item.typeId.includes("sea_pickle")){
                item.setLore([`Light: 13 Blocks`])
                inv.setItem(slot, item)
              }
              if(item.typeId.includes("sea_pickle")){
                item.setLore([`Light: 13 Blocks`])
                inv.setItem(slot, item)
              }
            }
          }
        }
        for(let types of torch7){
          if(item.typeId.includes(`${types}`)){
            if(!lore){
              item.setLore([`Light: 9 Blocks`])
              inv.setItem(slot, item)
            }
          }
        }
        for(let types of torch9){
          if(item.typeId.includes(`${types}`)){
            if(!lore){
              item.setLore([`Light: 11 Blocks`])
              inv.setItem(slot, item)
            }
          }
        }
        for(let types of torch5){
          if(item.typeId.includes(`${types}`)){
            if(!lore){
              item.setLore([`Light: 6 Blocks`])
              inv.setItem(slot, item)
            }
          }
        }
      }
    }

    for(let light of light_all){
      if(p.hasTag("mainhand") && !p.hasTag("offhand")){
        p.removeTag("mainhand")
        p.runCommandAsync(`execute as @s[hasitem={item=${light},location=slot.weapon.mainhand,quantity=0}] run function light0`);
      }
    }
    if(offhand){
      if(offhand.typeId.includes("new:torch_offhand")){
        p.addTag("offhand")
        p.runCommandAsync(`execute as @s positioned ~~1~ run function light12`);
      }
      if(offhand.typeId.includes("soul_torch_offhand")){
        p.addTag("offhand")
        p.runCommandAsync(`execute as @s positioned ~~1~ run function light9`);
      }
      if(offhand.typeId.includes("redstone_torch_offhand")){
        p.addTag("offhand")
        p.runCommandAsync(`execute as @s positioned ~~1~ run function light7`);
      }
      if(offhand.typeId.includes("totem_of_undying")){
        p.addTag("offhand")
        p.runCommandAsync(`execute as @s positioned ~~1~ run function light7`);
      }
    }

    if(hand && !p.hasTag("offhand")){
      for(let l13 of torch12){
        if(hand.typeId.includes(l13)){
          p.addTag("mainhand")
          if(!hand.typeId.includes("sea_pickle")){
            p.runCommandAsync(`execute as @s positioned ~~1~ run function light12`);
          }
        }
      }
      for(let l11 of torch9){
        if(hand.typeId.includes(l11)){
          p.addTag("mainhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function light9`);
        }
      }
      for(let l9 of torch7){
        if(hand.typeId.includes(l9)){
          p.addTag("mainhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function light7`);
        }
      }
      for(let l15 of torch15){
        if(hand.typeId.includes(l15)){
          if(hand.typeId != "minecraft:glowstone_dust"){
            p.addTag("mainhand")
            p.runCommandAsync(`execute as @s positioned ~~1~ run function light15`);
          }
        }
      }
      for(let l6 of torch5){
        if(hand.typeId.includes(l6)){
          p.addTag("mainhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function light5`);
        }
      }
    }
  } 
})